#ifndef _FILECAVETV
#define _FILECAVETV

/*
 *
 * This is part of the ANL/MCS/FL CAVEav distribution.
 * written by Ivan R. Judson
 *
 */

#include <GL/gl.h>
#include <GL/glu.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "CAVtv.h"
#include "TexturedPlane.h"

/** This is the derived class fileCAVEtv, which takes frames from a 
  sequence of rgb format files, and places them on a video pane on a 
  tv object in a CAVE scene.
  */

class fileCAVtv : public CAVtv {

public:
  /**@name Methods */
  //@{
    
  /// The constructor takes the following arguments, the x, y, z position of the TV the file basename to open for each frame, and the width, height and depth of the frames.
	  
  fileCAVtv(char *fn = "CCFrame", 
	    int width = 640, int height = 480, int depth = 3,
	     float x = 0.0, float y = 0.0, float z = 0.0);

  /// The destructor must cleanup the imagepool

  ~fileCAVtv(void);

  /// The init function

  void Init(void);

  /// This function reads the frame in

  void GetPix(void);

  /// This is the inherited draw function

  void Draw(void);

  /// This is the inherited process function

  void Process(void);

  //@}
protected:  
  
  /// Load data from a file

  int loadFile(char *filename);

  /// Private Init function

  void pInit(void);

private:
  /**@name Data */
  //@{
  
  /// Basename of files to read in

  char *_fnbase;

  TexturedPlane *tp_;

  /// Debugging data
  
  unsigned long *debugData_;

  /// Gross hack

  int initted_;

  //@}
};

#endif
